<?php

namespace App\Http\Controllers;

use App\Http\Requests\DraftOrderValidation;
use Illuminate\Http\Request;
use OhMyBrew\BasicShopifyAPI;
use App\Model\RechargeApi;

use Illuminate\Support\Facades\Auth;

use Config;

class SubscriptionController extends Controller
{

	private $rechargeObj;
	private $shop;
    private $domain; 
    


     /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct() {

    $this->rechargeObj   = new RechargeApi();
    
	if(isset($_REQUEST['shop'])) {
		$this->domain = $_REQUEST['shop'];
		

	}
	else {
		$this->domain = env('SHOP_DOMAIN',true);
		
	} 
	
	$shop = Auth::user();

	//$this->shop = ShopifyApp::shop($this->domain);
	

    }

    // To create order view
    public function editSubscription(){
    
    $shop = Auth::user();
    
    $order_id = $_REQUEST['id'];
	$Shopify_order = $shop->api()->rest('GET', '/admin/orders/'.$order_id.'.json', []);
	
	
	
	$Shopify_order = (object)$Shopify_order;
	
// 	dd($Shopify_order->body->order);
	
	if(!isset($Shopify_order->body->order)) {
		$message = "Order not found";
            	return view('subscription-error',["message" => $message]);
	}
	$Shopify_order = $Shopify_order->body;
        $order_details = ["id"=>$order_id,"name" => $Shopify_order->order->name, "customer_name" => $Shopify_order->order->customer->first_name, "email" => $Shopify_order->order->customer->email];
        $order =  $this->rechargeObj->getOrderBySopifyOrderId($order_id);
        
        // dd($order);
        
        if(isset($order->errors) || isset($order->error) || empty($order->orders)) {
            $message = "Failed to load order details from recharge";
            return view('subscription-error',["message" => $message]);
        }
        
        $subscription_id = $order->orders[0]->line_items[0]->subscription_id;
        $prod  = $this->setProductDetails();
        $jsonProductDetails = json_encode($prod); 
	    //$subscription_id = $_REQUEST['subscription_id'];
        $subscription =  $this->rechargeObj->getSubscription($subscription_id);
        if(isset($subscription->errors) || isset($subscription->error)) {
            $message = "Failed Load Subscription with the given id - ".$subscription_id;
            return view('subscription-error',["message" => $message]);
        }
        $lineitems = [];
        if(isset($subscription->subscription->properties) && !empty($subscription->subscription->properties)) {

            $lineitems = $subscription->subscription->properties;

        }
        
        return view('subscription-edit',['message'=>"",'subscriptionId'=>$subscription_id,'lineitems'=>$lineitems, "products" => $prod['variants'], "order" => $order_details],compact('jsonProductDetails'));
        
    }

    
    // To set the shopify product details
    private function setProductDetails() {

    $limit = 50;
    $nextLink = '';
    $previousLink = '';
    $prod  = [];
    $prod['products'] = [];
    $allVariants = [];
    
    $shop = Auth::user();

    do {
        try {

            if(empty($previousLink) && empty($nextLink)) {

                $productDetails = $shop->api()->rest('GET', 
                '/admin/products.json',["published_status" => "published", "fields" => 
                "id,title,variants", "limit" => $limit]);
                $productDetails = (object)$productDetails;
                
                $previousLink = !empty($productDetails->link->previous) ?
                $productDetails->link->previous : '';
                $nextLink = !empty($productDetails->link->next) ?
                $productDetails->link->next : '';
                
            }else {

                $params = ["fields" => "id,title,variants", "limit" => $limit, 
                'page_info' => $nextLink];
                $productDetails = $shop->api()->rest('GET', '/admin/products.json',$params);
                $productDetails = (object)$productDetails;
                
                $previousLink = !empty($productDetails->link->previous) ?
                $productDetails->link->previous : '';
                $nextLink = !empty($productDetails->link->next) ?
                $productDetails->link->next : '';
            }   
        } catch(Exception $e) {
            echo PHP_EOL."Error when fetching the products from shopify and the error is -  "
             .$e->getMessage();
             die;
        }

        $productDetails = $productDetails->body;
        
        if (!empty($productDetails)) {
            
            $subscription_product = array('1809168695367','4359186350162');
            
            foreach ($productDetails->products as $products) {
                if(in_array($products->id,$subscription_product)){
                    continue;
                }
               
                foreach ($products->variants as $variants) {
                    $allVariants[$variants->id] = [
                        'id' => $variants->id ,
                        'product_id' => $variants ->product_id,
                        'title' => strip_tags($products->title),
                        'variant_title' => strip_tags($variants->title),
                        'sku' => $variants->sku,
                        'price' => $variants->price
                    ];
                    $vari[$variants->id] = [
                        'id' => $variants->id ,
                        'product_id' => $variants->product_id,
                        'title' => strip_tags($variants->title),
                        'sku' => $variants->sku,
                        'price' => $variants->price
                    ];
                }
                
                $prod['products'][$products->id] = ['id'=>$products->id, 'title'=>strip_tags($products->title),'variants'=>$vari];
                $vari = [];
            }
            $prod['variants']=$allVariants;
        }
        $count = count($productDetails->products);  
        if(empty($nextLink)) {
            break;
        }
        } while($limit == $count);
        
        return $prod;
    }

    public function saveSubscription(Request $req) {
        
        $shop = Auth::user();
        
        $subscription_id = (int)$req['subscriptionId'];
        $order_id = (int)$req['orderId'];
        $Shopify_order = $shop->api()->rest('GET', '/admin/orders/'.$order_id.'.json', []);
        $Shopify_order = (object)$Shopify_order;
        
        $Shopify_order = $Shopify_order->body;
        $order_details = ["id"=>$order_id,"name" => $Shopify_order->order->name, "customer_name" => $Shopify_order->order->customer->first_name, "email" => $Shopify_order->order->customer->email];
        $subscriptionRequest = $this->setSubscriptionRequest($req);
        $subscriptionRequest['subscription_id'] = $subscription_id;
        $result = $this->rechargeObj->updateSubscription(json_encode($subscriptionRequest));
        
        // dd($result);
        
        $message = "";
        if($result['status'] == "failed") {
            $message = $result['errorMessage'];
        }
        else{
            $message = "Subscription updated successfully"; 
        }
        $prod  = $this->setProductDetails();
        $jsonProductDetails = json_encode($prod); 
        $subscription =  $this->rechargeObj->getSubscription($subscription_id);
        if(isset($subscription->errors) || isset($subscription->error)) {
            $error = "Failed Load Subscription with the given id - ".$subscription_id;
            return view('subscription-edit',$error);
        }
        $lineitems = [];
        if(isset($subscription->subscription->properties) && !empty($subscription->subscription->properties)) {

            $lineitems = $subscription->subscription->properties;

        }
        
        return view('subscription-edit',['message'=>$message,'subscriptionId'=>$subscription_id,'lineitems'=>$lineitems, "products" => $prod['variants'],"order" => $order_details],compact('jsonProductDetails'));
    }
    
    public function setSubscriptionRequest($reqObj){
        //$validated = $reqObj->validated();
        $request = [];
        $lineProperTies = [];
        $prod  = $this->setProductDetails();
        $i = 1;
        foreach ($reqObj['prod-variant-id'] as $key => $variantId){
            $propertyValue = '';
            
            if($i < 10){
                $propertyKey = 'Vitamin0'.$i;
            }else if($i >= 10){
                $propertyKey = 'Vitamin'.$i;
            }
            
            if (isset($prod['variants'][$variantId])){

               

                    if (isset($reqObj['prod-qty'][$key])){

                        $propertyValue .= $prod['variants'][$variantId]['title'] . ' | '. 
                                    $prod["variants"][$variantId]['variant_title']. ' | ' .  
                                    $reqObj['prod-qty'][$key] . ' | ' . 
                                    $variantId. ' | ' . 
                                    $prod["variants"][$variantId]['sku'];

                        $lineProperTies[] = ['name'=>$propertyKey,'value'=>$prod['variants'][$variantId]['title'], 'product_id' =>$prod["variants"][$variantId]['product_id'], 'variant_id' => $variantId, 'quantity' => $reqObj['prod-qty'][$key], 'dosage' => $prod["variants"][$variantId]['variant_title'] ];

                    }

                
                
             }
             $i++;
        }
        $request['properties'] = $lineProperTies;
        $subscription =  $this->rechargeObj->getSubscription($reqObj['subscription_id']);
        $lineitems = [];
        if(isset($subscription->subscription->properties) && !empty($subscription->subscription->properties)) {

            $lineitems = $subscription->subscription->properties;
            foreach($lineitems as $item) {
                if(strpos($item->name , "Vitamin") === false) {
                    $addItem = ["name"=>$item->name, "value" =>$item->value];
                    $request['properties'][] = $addItem;
                }
            }
        }
        
       

        return $request;

    }
}
?>
